;From Squest@concentric.net Thu Feb  6 09:56:24 1997
;Date: Tue, 04 Feb 1997 00:34:06 -0800
;From: "Steve J. Quest" <Squest@concentric.net>
;To: 8051code@keil.com
;Subject: Let me be the first to contribute.

; This program will dump a block of program
; code to the 8051 serial port in Intel HEX
; format.  It was a quick and nasty hack to
; fulfill a need, however it includes a good
; checksum calculation routine, which is nice.
; For simplicity, this program dumps Intel HEX
; in 16 byte strings only.  Usually, this is
; not a problem, as I used this code typically
; for dumping HEX to be disassembled.  It is
; assumed that the serial port is preconfigured.
;
; This software is public domain, you may use
; it or abuse it in any way you wish, however,
; if you make money with it, please remember
; the poor starving author of this tiny bit
; of code, Steve J. Quest - squest@cris.com
;
;
;	HexDump Utility - S. Quest '86
;	Start addr lo/hi = 7ah, 7bh
;	End addr lo/hi = 7ch, 7dh
;
	org	8000h
;
	mov	a,7ch
	orl	a,#00001111b
	mov	7ch,a
	mov	dpl,7ah
	mov	dph,7bh
mloop:	acall	lfcr
	mov	a,#':'
	acall	sbyte
	mov	a,#'1'
	acall	sbyte
	mov	a,#'0'
	acall	sbyte
	mov	r1,#10h
	mov	a,dph
	acall	cvhex
	mov	a,dpl
	acall	cvhex
	mov	a,#'0'
	acall	sbyte
	acall	sbyte
	mov	r2,#10h
dfdmp:	mov	a,#0
	movc	a,@a+dptr
	acall	cvhex
	mov	a,dpl
	cjne	a,7ch,ntdn
	mov	a,dph
	cjne	a,7dh,ntdn
	acall	cksum
	acall	lfcr
	mov	a,#':'
	acall	sbyte
	mov	r3,#7h
zfill:	mov	a,#'0'
	acall	sbyte
	djnz	r3,zfill
	mov	a,#'1'
	acall	sbyte
	mov	a,#'F'
	acall	sbyte
	acall	sbyte
	acall	lfcr
	ljmp	osret
ntdn:	inc	dptr
	djnz	r2,dfdmp
	acall	cksum
	sjmp	mloop
;
sbyte:	clr	ti
	mov	sbuf,a
txwt:	jnb	ti,txwt
	ret
;
cvhex:	push	acc
	push	acc
	add	a,r1
	mov	r1,a
	pop	acc
	swap	a
	acall	modif
	pop	acc
	acall	modif
	ret
modif:	anl	a,#00001111b
	add	a,#0f6h
	jnc	lorng
	add	a,#7h
lorng:	add	a,#3ah
	acall	sbyte
	ret
;
cksum:	mov	a,r1
	cpl	a
	inc	a
	acall	cvhex
	ret
;
lfcr:	mov	a,#0dh
	acall	sbyte
	mov	a,#0ah
	acall	sbyte
	ret
;
osret:  equ     0h      ; adapt this value to your ap.
;
	end
